this.name        = "ups_sun"; 
this.author      = "eric walch"; 
this.copyright   = " 2008 the Oolite team."; 
this.description = "Solar missions of UPS Courier"; 
this.version     = "1.3.1"; 


this.startUp = function()
{
    if (oolite.compareVersion("1.70") > 0)
    {
        // Oolite version is older than 1.70.
        LogWithClass("script."+this.name, "This UPS-Courier missions does not run under Oolite version " + oolite.versionString + " Sun missions are disabled.")
        delete this.missionScreenEnded
        delete this.shipExitedWitchspace
        delete this.shipLaunchedFromStation
        delete this.shipDockedWithStation
    }
}

this.shipDockedWithStation = function()
{
// missionVariables.ups_sunbase is set to "YES" by a mission in ups_docs.
    if (missionVariables.ups_sunbase == "YES")
    {
        this.ups_missionoffers()
    }
}

this.missionScreen=function(messageKey, backGround, choiceKey)
{
        mission.showShipModel();mission.setMusic()
	mission.setBackgroundImage(backGround);
	mission.showMissionScreen();
	mission.addMessageTextKey(messageKey);
        if (choiceKey != null) mission.setChoicesKey(choiceKey)
}

this.ups_missionoffers = function()
{
    if (player.dockedStation.isMainStation && guiScreen != "GUI_SCREEN_MISSION")
    {
        if (missionVariables.ups_sun == "YES")
        {
            if (system.techLevel > 10 && !mission.choice && !missionVariables.offering)
            {
                missionVariables.ups_stationparts = ExpandDescription("[ups_stationparts]")
                this.missionScreen("ups_sun_offer", "UPS.png", "ups_sun_accepted_yesno")
                missionVariables.offering ="UPS_SOLAR1"
            }
        }
        if (missionVariables.ups_sun == "RESCUEOFFER")
        {
            if (system.government > 1 && !mission.choice && !missionVariables.offering)
            { 
                this.missionScreen("ups_sun_offer3", "solar.png", "ups_sun_accepted3_yesno")
                missionVariables.offering = "UPS_SOLAR3" 
                missionVariables.ups_stimerstart = clock.days
            }
        }
        if (missionVariables.ups_sun == "EXPLOSION")
        {
            if (!mission.choice && !missionVariables.offering)
            { 
                missionVariables.ups_s2award = missionVariables.ups_s2award // removing tailing zero's from string
                if (missionVariables.ups_s2count == "0") { this.missionScreen("ups_sun_unloading3a", "UPS.png", null)}
                else {this.missionScreen("ups_sun_unloading3", "UPS.png", null)}
                missionVariables.ups_sunvisits++
                mission.setInstructionsKey() 
//              mission.unmarkSystem(missionVariables.ups_splanet) // this command crashes Oolite 1.70!
                player.call("removeMissionDestination:", missionVariables.ups_splanet)
                player.credits += missionVariables.ups_s2award 
                missionVariables.ups_sun = "FINISHED" 
                missionVariables.ups_sunreset = "YES"
            }
        }
        if (missionVariables.ups_sun == "RESCUE")
        {
            if ((clock.days - missionVariables.ups_stimerstart) > 20 && !mission.choice && !missionVariables.offering)
            {
                missionVariables.ups_sun = "FINISHED" 
                missionVariables.ups_difference = pasttime 
                this.missionScreen("ups_sun_explosion", "solar.png", null)
                mission.setInstructionsKey() 
    //          mission.unmarkSystem(missionVariables.ups_splanet)  // this command crashes Oolite 1.70!
                player.call("removeMissionDestination:", missionVariables.ups_splanet)
                missionVariables.ups_sunreset = "YES" 
                missionVariables.ups_rescue = "EXPLOSION"
            }
        }
    }
    if (player.dockedStation.shipDescription == "Sun Research Station Alpha"&& guiScreen != "GUI_SCREEN_MISSION")
    {
        if (missionVariables.ups_sun == "SMALL_DELIVERY" && !missionVariables.offering)
        {
                this.missionScreen("ups_sun_unloading", "UPS.png", null)
                missionVariables.ups_sunvisits++
                player.credits += 250
                mission.setInstructionsKey() 
                missionVariables.ups_sun = "NOT_NOW" 
                missionVariables.ups_stationparts = null
    //                mission.unmarkSystem(missionVariables.ups_splanet)  // this command crashes Oolite 1.70!
                player.call("removeMissionDestination:", missionVariables.ups_splanet)
                player.call("increaseContractReputation")
        }
        if (missionVariables.ups_scount && missionVariables.ups_scount > 0 && !missionVariables.ups_blackbox && !missionVariables.offering && !mission.choice)
        {
                this.missionScreen("ups_sun_offer2", "UPS.png", "ups_sun_accepted2_yesno")
                missionVariables.ups_blackbox = "OFFERED"
        } 
        if (missionVariables.ups_blackbox && missionVariables.ups_blackbox == "SEARCHING" && !missionVariables.offering && !mission.choice)
        {
                missionVariables.ups_s2award = missionVariables.ups_s2award // remove trailing zero's
                if (missionVariables.ups_s2count == "0")
                {
                    this.missionScreen("ups_sun_unloading2a", "UPS.png", null)
                    missionVariables.ups_blackbox = null
                }
                else
                { 
                    this.missionScreen("ups_sun_unloading2", "UPS.png", null)
                    missionVariables.ups_blackbox = "FINISHED"
                } 
                player.credits += s2award
                mission.setInstructionsKey() 
                missionVariables.ups_s2count = null
                missionVariables.ups_s2award = null
        }
        if (missionVariables.ups_sun == "RESCUE" && !missionVariables.ups_rescue && !missionVariables.offering)
        {
                this.missionScreen("ups_sun_rescue", "solar.png", null)
                mission.setInstructionsKey("ups_sun_small4") 
                missionVariables.ups_rescue = "YES", 
                missionVariables.ups_s2count = "10", 
                missionVariables.ups_s2award = "1500", 
                missionVariables.ups_sun = "EXPLOSION"
        }
    }
}


this.missionScreenEnded = function()
{
    if (missionVariables.ups_sunbase == "YES") 
    {
        if (missionVariables.offering == "UPS_SOLAR1")
        {
            if (mission.choice == "YESSun")
            {
                mission.markSystem(missionVariables.ups_splanet) 
                mission.clearMissionScreen() 
                mission.resetMissionChoice()
                mission.setInstructionsKey("ups_sun_small") 
                missionVariables.ups_sun = "SMALL_DELIVERY" 
                missionVariables.offering = null
            }
            else
            {
                if (mission.choice == "NOSun")
                { 
                    mission.clearMissionScreen() 
                    mission.resetMissionChoice()
                    missionVariables.ups_sun = "NOT_NOW" 
                    missionVariables.offering = null
                    missionVariables.ups_stationparts = null
                }
            }
        }
        if (missionVariables.offering == "UPS_SOLAR3")
        {
            if (mission.choice == "YESSun")
            { 
                mission.markSystem(missionVariables.ups_splanet) 
                mission.clearMissionScreen() 
                mission.setInstructionsKey("ups_sun_small3") 
                missionVariables.ups_sun = "RESCUE" 
                missionVariables.offering = null
            }
            else
            {
                if (mission.choice == "NOSun")
                { 
                    mission.clearMissionScreen() 
                    missionVariables.ups_sun = "RESCUE" 
                    missionVariables.offering = null
                }
            }
        }
        if (missionVariables.ups_blackbox == "OFFERED")
        {
            if (mission.choice == "YESSun")
            {
                    missionVariables.ups_blackbox = "YES", 
                    mission.clearMissionScreen() 
                    mission.setInstructionsKey("ups_blackbox_small") 
            }
            else
            {
                    if (mission.choice == "NOSun")
                    {
                        missionVariables.ups_blackbox = "NO"
                        mission.clearMissionScreen() 
                    }
            } 
        }
        this.ups_missionoffers()
    }
}

this.setUpShips_ups_sun = function()
{
        if (missionVariables.ups_splanet == system.ID)
        {
            if (system.countShipsWithRole("ups_dependance") == 0 && !missionVariables.ups_rescue)
            {
                    if (missionVariables.ups_sun == "RESCUE")
                    {
                        system.legacy_addShipsAt("ups_dependanceJS", 1, "sps", 0, 0, 1.5)
                        missionVariables.ups_s2count = "0"
                    }
                    else
                    {
                        system.legacy_addShipsAt("ups_dependance", 1, "sps", 0, 0, 2.6) 
                        system.legacy_addShipsAt("ups-sunskim", 3, "sps", 0, 0, 2.6) 
                        system.legacy_addShipsAt("ups_shuttle", 8, "sps", 0, 0, 2.6)
                    }
                    system.legacy_addShipsAt("ups-sunskim", 1, "spu", 0, 0, 0.2) 
                    system.legacy_addShipsAt("ups-sunskim", 1, "spu", 0, 0, 0.4) 
                    system.legacy_addShipsAt("ups-sunskim", 1, "spu", 0, 0, 0.6) 
                    system.legacy_addShipsAt("ups-sunskim", 1, "spu", 0, 0, 0.8) 
                    system.legacy_addShipsAt("ups-sun-police", 4, "spu", 0, 0, 0.5) 
                    system.legacy_addShipsAt("ups-sunskim", 1, "swu", 0, 0, 0.2) 
                    system.legacy_addShipsAt("ups-sunskim", 1, "swu", 0, 0, 0.4) 
                    system.legacy_addShipsAt("ups-sunskim", 1, "swu", 0, 0, 0.6) 
                    system.legacy_addShipsAt("ups-sunskim", 1, "swu", 0, 0, 0.8) 
            }
        }
}

this.shipExitedWitchspace = function()
{
    if (missionVariables.ups_sunbase == "YES") 
    {
        this.setUpShips_ups_sun();
        if (missionVariables.ups_blackbox == "FINISHED")
        {
            if (missionVariables.ups_sunvisits && missionVariables.ups_sunvisits > 3  && Math.random() < 0.3)
            {// make sure missionVariables.ups_sunvisits is defined before checking a value.
                missionVariables.ups_blackbox = null
            }
        }
        else
        {
            if (missionVariables.ups_blackbox == "SEARCHING") {mission.setInstructionsKey()}
            missionVariables.ups_blackbox = null
            missionVariables.ups_scount = null
        }
        if (missionVariables.ups_sunreset && missionVariables.ups_sunreset == "YES")
        {
                missionVariables.ups_sunreset = null 
                mission.setInstructionsKey() 
    //            mission.unmarkSystem(missionVariables.ups_splanet)  // this command crashes Oolite 1.70!
                player.call("removeMissionDestination:", missionVariables.ups_splanet)
                missionVariables.ups_splanet = null 
                missionVariables.ups_splanetname = null
                missionVariables.ups_sun = null
                missionVariables.ups_scount = null
                missionVariables.ups_scount = null 
                missionVariables.ups_s2award = null 
                missionVariables.ups_s2count = null
                missionVariables.ups_blackbox = null
                missionVariables.ups_sunvisits = null
                missionVariables.ups_sunbase = null
                missionVariables.ups_stimerstart = null 
                missionVariables.ups_stationparts = null
                missionVariables.ups_rescue = null
        } 
        if (missionVariables.ups_sun == "NOT_NOW" && Math.random() < 0.1) {missionVariables.ups_sun = "NO"}
        if (missionVariables.ups_sun == "NO")
        {
            if (system.techLevel > 10 && Math.random() < 0.2){missionVariables.ups_sun = "YES"}
            else
            {
                if (system.government > 1 && Math.random() < 0.1 && missionVariables.ups_sunvisits && missionVariables.ups_sunvisits > 4)
                {missionVariables.ups_sun = "RESCUEOFFER"}
            }    
        }
    }
}

this.shipLaunchedFromStation = function()
{
    if (missionVariables.ups_sunbase == "YES") 
    {
        this.setUpShips_ups_sun();
        if (missionVariables.ups_blackbox == "YES")
        {
                missionVariables.ups_blackbox = "SEARCHING" 
                missionVariables.ups_s2count = "0" 
                missionVariables.ups_s2award = "0"
                let scount =  missionVariables.ups_scount
                system.legacy_addShipsAt("UPS-black_box", scount, "sps", 0, 0, 1.1) 
                missionVariables.ups_scount = null
        }
    }
}